/**
 *    
 */
public class ElevatorAutomats
{
	protected ElevatorVisualizerInterface vis;
	protected ElevatorLogInterface log;
	
	ElevatorAutomats( ElevatorVisualizerInterface vis,
					  ElevatorLogInterface log )
	{
		this.vis = vis;
		this.log = log;
	}
	
	protected int y0 = 0;
	/**
	*  A0
	*/
	public void A0( int e )
	{
		int y_old = y0;
		boolean xx61;
		boolean xx62;
		boolean xx63;
		log.begin( 0, y0, e );
		switch ( y0 )
		{
		case 0:
			xx61 = vis.x61();
			xx62 = vis.x62();
			xx63 = vis.x63();
			if ( ( xx61 && y11 == 1 ) || 
				 ( xx62 && ( y21 == 1 || y22 == 1 ) ) || 
				 ( xx63 && y32 == 1 ) )
			{					vis.z700();	vis.z501();				y0 = 3; }
			else if ( ( ( xx61 && 
						( y32 == 1 || y21 == 1 || y22 == 1 ) ) 
						|| ( xx62 && y32 == 1 ) ) && y1 == 1 )
			{														y0 = 1; }
			else if ( ( xx63 && 
						( y11 == 1 || y21 == 1 || y22 == 1 ) )
						|| ( xx62 && y11 == 1 ) )
			{														y0 = 2; }
			else if ( ( xx61 && 
						( y32 == 1 || y21 == 1 || y22 == 1 ) )
						|| ( xx62 && y32 == 1 ) )
			{														y0 = 1; }
			break;

		case 1:
		case 2:
			if ( ( vis.x61() && y11 == 1 ) || 
				 ( vis.x62() && ( y21 == 1 || y22 == 1 ) )
				 || ( vis.x63() && y32 == 1 ) )
			{					vis.z700();	vis.z501();				y0 = 3; }
			break;

		case 3:
			if ( e == 80 )
			{					vis.z800();							y0 = 4; }
			break;

		case 4:
			if ( e == 90 )
			{														y0 = 5; }
			else if ( vis.x51() )
			{					vis.z900();							y0 = 6; }
			break;

		case 5:
			if ( e == 81 )
			{					vis.z800();							y0 = 0; }
			else if ( y2 == 4 || vis.x51() )
			{					vis.z800();							y0 = 3; }
			break;

		case 6:
			if ( y2 == 1 || y2 == 2 || y2 == 3 )
			{														y0 = 7; }
			else if ( !vis.x51() )
			{														y0 = 4; }
			break;

		case 7:
			if ( e == 81 )
			{					vis.z800();							y0 = 9; }
			else if ( y2 == 4 )
			{					vis.z800();							y0 = 8; }
			else if ( !vis.x51() )
			{					vis.z800();							y0 = 3; }
			break;

		case 8:
			if ( !vis.x51() )
			{														y0 = 3; }
			else if ( e == 80 )
			{					vis.z800();							y0 = 6; }
			break;

		case 9:
			xx61 = vis.x61();
			xx62 = vis.x62();
			xx63 = vis.x63();
			if ( y2 ==4 )
			{														y0 = 8; }
			else if ( ( y2 == 2 && xx61 ) || 
					  ( y2 == 3 && ( xx61 || xx62 ) ) )
			{														y0 = 10; }
			else if ( ( y2 == 2 && xx63 ) || 
					  ( y2 == 1 && ( xx63 || xx62 ) ) )
			{														y0 = 11; }
			break;

		case 10:
			xx61 = vis.x61();
			xx62 = vis.x62();
			xx63 = vis.x63();
			if ( ( y2 == 4 && ( xx61 || xx62 || xx63 ) ) ||
				 ( y2 == 1 && xx61 ) || ( y2 == 2 && xx62 )
			  || ( y2 == 3 && xx63 ) || ( y21 == 1 && xx62 ) )
			{					vis.z700();							y0 = 8; }
			break;

		case 11:
			xx61 = vis.x61();
			xx62 = vis.x62();
			xx63 = vis.x63();
			if ( ( y2 == 4 && ( xx61 || xx62 || xx63 ) ) ||
				 ( y2 == 1 && xx61 ) || ( y2 == 2 && xx62 ) ||
				 ( y2 == 3 && xx63 ) || ( y22 == 1 && xx62 ) )
			{					vis.z700();							y0 = 8; }
			break;

		default:
			log.error( 0, " " );
		}
		
		if ( y_old != y0 )
		{
			log.trans( 0, y_old, y0 );
			switch ( y0 )
			{
			case 0:
				A11( 4 ); A21( 4 ); A22( 4 ); A32( 4 );
				vis.z500();
				break;

			case 1:
				A1( 9 );
				vis.z701();
				break;

			case 2:
				A1( 8 );
				vis.z702();
				break;

			case 3:
				A2( 2 ); A11( 3 ); A21( 3 ); A22( 3 ); A32( 3 );
				vis.z801();
				break;

			case 4:
				vis.z901();
				break;

			case 5:
				vis.z802();
				break;

			case 7:
				vis.z802();
				break;

			case 8:
				A2( 2 ); A11( 3 ); A21( 3 ); A22( 3 ); A32( 3 );
				vis.z801();
				break;

			case 9:
				A11( 4 ); A21( 4 ); A22( 4 ); A32( 4 );
				break;

 
			case 10:
				A1( 9 );
				vis.z701();
				break;

			case 11:
				A1( 8 );
				vis.z702();
				break;
			}
		}
		log.end( 0, y0, e );
	}

	protected int y1 = 0;
	/**
	*  A1
	*/
	public void A1( int e )
	{
		int y_old = y1;
		log.begin( 1, y1, e );
		if ( y1 == 0 && e == 9 ) 									y1 = 1;
		else if ( y1 == 1 && e == 8 ) 								y1 = 0;
		if ( y_old != y1 )
			log.trans( 1, y_old, y1 );
		log.end( 1, y1, e );
	}

	protected int y2 = 0;
	/**
	*  A2
	*/
	public void A2( int e )
	{
		int y_old = y2;
		log.begin( 2, y1, e );
		switch ( y2 )
		{
		case 0:
			boolean xx51 = vis.x51();
			if ( e == 41 && xx51 && !vis.x61() )
			{														y2 = 1; }
			else if ( e == 42 && xx51 && !vis.x62() )
			{														y2 = 2; }
			else if ( e == 43 && xx51 && !vis.x63() )
			{														y2 = 3; }
			else if ( e == 44 && y0 == 5 )
			{														y2 = 4; }
			break;

		case 1:
		case 2:
		case 3:
			if ( e == 44 && ( y0 == 7 || y0 == 10 || y0 == 11 ) )
			{					vis.z400();							y2 = 4; }
			else if ( e == 2)
			{														y2 = 0; }
			break;

		case 4:
			if ( e == 2 )
			{														y2 = 0; }
			break;

		default:
			log.error( 0, " " );
		}
		
		if ( y_old != y2 )
		{
			log.trans( 2, y_old, y2 );
			switch ( y2 )
			{
			case 0:
				vis.z400();
				break;

			case 1:
				vis.z411();
				break;

			case 2:
				vis.z421();
				break;

			case 3:
				vis.z431();
				break;

			case 4:
				vis.z441();
				break;
			}
		}
		log.end( 2, y2, e );
	}

	protected int y11 = 0;
	/**
	*  A11
	*/
	public void A11( int e )
	{
		int y_old = y11;
		log.begin( 11, y11, e );
		switch ( y11 )
		{
		case 0:
			if ( e == 11 )
			{														y11 = 1; }
			else if ( e == 3 && vis.x61() )
			{														y11 = 2; }
			break;

		case 1:
			if ( e == 3 && vis.x61() )
			{														y11 = 2; }
			break;

		case 2:
			if ( e == 4 )
			{														y11 = 0; }
			break;
		}

 
		if ( y_old != y11 )
		{
			log.trans( 11, y_old, y11 );
			if ( y11 == 1 )			vis.z111();
			else if ( y11 == 2 )	vis.z110();
		}
		log.end( 11, y11, e );
	}

	protected int y21 = 0;
	/**
	*  A21
	*/
	public void A21( int e )
	{
		int y_old = y21;
		log.begin( 21, y21, e );
		switch ( y21 )
		{
		case 0:
			if ( e == 21 )
			{														y21 = 1; }
			else if ( e == 3 && vis.x62() )
			{														y21 = 2; }
			break;

		case 1:
			if ( e == 3 && vis.x62() )
			{														y21 = 2; }
			break;

		case 2:
			if ( e == 4 )
			{														y21 = 0; }
			break;
		}

		if ( y_old != y21 )
		{
			log.trans( 21, y_old, y21 );
			if ( y21 == 1 )			vis.z211();
			else if ( y21 == 2 )	vis.z210();
		}
		log.end( 21, y21, e );
	}

	protected int y22 = 0;
	/**
	*  A22
	*/
	public void A22( int e )
	{
		int y_old = y22;
		log.begin( 22, y22, e );
		switch ( y22 )
		{
		case 0:
			if ( e == 22 )
			{														y22 = 1; }
			else if ( e == 3 && vis.x62() )
			{														y22 = 2; }
			break;

 
		case 1:
			if ( e == 3 && vis.x62() )
			{														y22 = 2; }
			break;                         

		case 2:
			if ( e == 4 )
			{														y22 = 0; }
			break;
		}

		if ( y_old != y22 )
		{
			log.trans( 22, y_old, y22 );
			if ( y22 == 1 )			vis.z221();
			else if ( y22 == 2 )	vis.z220();
		}
		log.end( 22, y22, e );
	}

	protected int y32 = 0;
	/**
	*  A32
	*/
	public void A32( int e )
	{
		int y_old = y32;
		log.begin( 32, y32, e );
		switch ( y32 )
		{
		case 0:
			if ( e == 32 )
			{														y32 = 1; }
			else if ( e == 3 && vis.x63() )
			{														y32 = 2; }
			break;

		case 1:
			if ( e == 3 && vis.x63() )
			{														y32 = 2; }
			break;

		case 2:
			if ( e == 4 )
			{														y32 = 0; }
			break;

		}
		if ( y_old != y32 )
		{
			log.trans( 32, y_old, y32 );
			if ( y32 == 1 )			vis.z321();
			else if ( y32 == 2 )	vis.z320();
		}
		log.end( 32, y32, e );
	}
}
